#ifndef __MISC_H__
#define __MISC_H__

#define timediff(tv2, tv1)  (((tv2)->tv_sec - (tv1)->tv_sec)*1000*1000 + \
                             ((tv2)->tv_usec - (tv1)->tv_usec))

void dump_u8_buffer (u8 *buf, int number);
void dump_u16_buffer (u16 *buf, int number);
void dump_u32_buffer (u32 *buf, int number);
void dump_buffer (unsigned char *buf, int size);
int my_memcmp (char *buf1, char *buf2, int size);
int parsehex (char *hex, char *buf);
void net2host (char *x, int size);
int make_random_buf (char *buf, int size);
int swab32_buf (char *buf, int size);

void init_ciphers_and_digests (void);

/* #define ALL_CIPHERS =                                                   \ */
/* {  "serpent-ecb", "serpent-cbc", "mars-ecb", "mars-cbc",                \ */
/*    "rc5-ecb", "rc5-cbc", "rc6-ecb", "rc6-cbc", "dfc-ecb", "dfc-cbc",    \ */
/*    "aes-ecb", "aes-cbc", "blowfish-ecb", "blowfish-cbc",                \ */
/*    "twofish-ecb", "twofish-cbc", "idea-ecb", "idea-cbc",                \ */
/*    "des-ecb", "des-cbc", "des-ede3-ecb", "des-ede3-cbc"                 \ */
/* } */

extern int __init_cryptoapi (void);

extern int __init_serpent (void);
extern int __init_mars (void);
extern int __init_rc5 (void);
extern int __init_rc6 (void);
extern int __init_dfc (void);
extern int __init_rijndael (void);
extern int __init_blowfish (void);
extern int __init_twofish (void);
extern int __init_idea (void);
extern int __init_des (void);
extern int __init_des_ede3 (void);

extern int __init_md5 (void);
extern int __init_sha1 (void);

#endif /* __MISC_H__ */
